
CREATE TABLE alkis.pp_punktnummernuebersicht
(
  ogc_fid serial NOT NULL,
  punktkennung character varying,
  wkb_geometry geometry(Point,25832),
  art text,
  hinweise character varying,
  genauigkeitsstufe integer,
  punktnummer character varying,
  stelle integer,
  kreis character varying,
  gid serial NOT NULL,
  CONSTRAINT pp_punktnummernuebersicht_pk PRIMARY KEY (gid)
)
WITH (
  OIDS=TRUE
);


-- Index: alkis.pp_punktnummernuebersicht_geom_idx

-- DROP INDEX alkis.pp_punktnummernuebersicht_geom_idx;

CREATE INDEX pp_punktnummernuebersicht_geom_idx
  ON alkis.pp_punktnummernuebersicht
  USING gist
  (wkb_geometry);

-- Index: alkis.pp_punktnummernuebersicht_hinweise_idx

-- DROP INDEX alkis.pp_punktnummernuebersicht_hinweise_idx;

CREATE INDEX pp_punktnummernuebersicht_hinweise_idx
  ON alkis.pp_punktnummernuebersicht
  USING btree
  (hinweise COLLATE pg_catalog."default");

-- Index: alkis.pp_punktnummernuebersicht_kreis_idx

-- DROP INDEX alkis.pp_punktnummernuebersicht_kreis_idx;

CREATE INDEX pp_punktnummernuebersicht_kreis_idx
  ON alkis.pp_punktnummernuebersicht
  USING btree
  (kreis COLLATE pg_catalog."default");

-- Index: alkis.pp_punktnummernuebersicht_stelle_idx

-- DROP INDEX alkis.pp_punktnummernuebersicht_stelle_idx;

CREATE INDEX pp_punktnummernuebersicht_stelle_idx
  ON alkis.pp_punktnummernuebersicht
  USING btree
  (stelle);

