<?php
/*	Modul: alkisnamstruk.php

	ALKIS-Buchauskunft, Kommunales Rechenzentrum Minden-Ravensberg/Lippe (Lemgo).
	Namens- und Adressdaten fuer einen Eigentuemer aus ALKIS PostNAS

	Version:
	2016-02-24 Version fuer norGIS-ALKIS-Import
	2016-11-29 HTML5, Gemeinsam genutzte Datenbanken ermöglichen
*/
session_start();
$id="n";
$multiadress="n";
$cntget = extract($_GET);
require_once("alkis_conf_location.php");
if ($auth == "mapbender") {require_once($mapbender);}
include("alkisfkt.php");
$keys = isset($_GET["showkey"]) ? $_GET["showkey"] : "n";
if ($keys == "j") {$showkey=true;} else {$showkey=false;}

?>
<!doctype html>
<html lang="de">
<head>
	<meta charset="utf-8">
	<title>ALKIS Person und Adresse</title>
	<link rel="stylesheet" type="text/css" href="alkisauszug.css">
	<link rel="shortcut icon" type="image/x-icon" href="ico/Eigentuemer_2.ico">
	<script type="text/javascript">
		function ALKISexport() {
			window.open(<?php echo "'alkisexport.php?gkz=".$gkz."&tabtyp=person&gmlid=".$gmlid."'"; ?>);
		}
	</script>
	<style type='text/css' media='print'>
		.noprint {visibility: hidden;}
	</style>
</head>
<body>

<?php

// Balken
echo "<p class='nakennz'>ALKIS Name id=".$gmlid."&nbsp;</p>\n"
."\n<h2><img src='ico/Eigentuemer.png' width='16' height='16' alt=''> Person</h2>\n";
$con = pg_connect($dbconn." options='--application_name=ALKIS-Auskunft_alkisnamstruk.php'");
if (!$con) "\n<p class='err'>Fehler beim Verbinden der DB</p>\n";

$sql="SELECT p.nachnameoderfirma, p.anrede, p.vorname, p.geburtsname, p.geburtsdatum, p.namensbestandteil, p.akademischergrad, a.v AS anrv
FROM ax_person p LEFT JOIN alkis_wertearten a ON cast(p.anrede AS character varying)=a.k AND a.element='ax_person' AND a.bezeichnung='anrede' 
WHERE gml_id= $1;";

$v = array($gmlid);
$res = pg_prepare("", $sql);
$res = pg_execute("", $v);

if (!$res) {
	echo "\n<p class='err'>Fehler bei Zugriff auf Namensnummer</p>\n";
	if ($debug > 2) {echo "<p class='dbg'>SQL=<br>".$sql."<br>$1 = gml_id = '".$gmlid."'</p>";}
}
if ($row = pg_fetch_array($res)) {
	$vor=htmlentities($row["vorname"], ENT_QUOTES, "UTF-8");
	$nam=htmlentities($row["nachnameoderfirma"], ENT_QUOTES, "UTF-8");
	$geb=htmlentities($row["geburtsname"], ENT_QUOTES, "UTF-8");
	$anrk=$row["anrede"]; // Key
	$anr=$row["anrv"]; // Value
	$nbest=$row["namensbestandteil"];
	$aka=$row["akademischergrad"];

	echo "<table>\n"
		."\t<tr><td class='nhd'>Anrede:</td><td class='nam'>";
		if ($showkey) {echo "<span class='key' title='Anredekennung'>(".$anrk.")</span> ";}
		echo $anr."</td></tr>\n"
		."\t<tr><td class='nhd'>Nachname oder Firma:</td><td class='nam'>".$nam."</td></tr>\n"
		."\t<tr><td class='nhd'>Vorname:</td><td class='nam'>".$vor."&nbsp;</td></tr>\n"
		."\t<tr><td class='nhd'>Geburtsname:</td><td class='nam'>".$geb."&nbsp;</td></tr>\n"
		."\t<tr><td class='nhd'>Geburtsdatum:</td><td class='nam'>".$row["geburtsdatum"]."&nbsp;</td></tr>\n"
		."\t<tr><td class='nhd'>Namensbestandteil:</td><td class='nam'>".$nbest."&nbsp;</td></tr>\n"
		."\t<tr><td class='nhd'>akademischer Grad:</td><td class='nam'>".$aka."&nbsp;</td></tr>\n"
	."\n</table>\n<hr>\n";

	// A d r e s s e
	echo "\n<h3><img src='ico/Strasse_mit_Haus.png' width='16' height='16' alt=''> Adresse</h3>\n";
	// Es können redundante Adressen vorhanden sein, z.B. aus Migration, temporär aus LBESAS. Die letzte davon anzeigen.

	$sqla ="SELECT a.gml_id, a.ort_post, a.postleitzahlpostzustellung AS plz, a.strasse, a.hausnummer, a.bestimmungsland 
	FROM ax_anschrift a JOIN ax_person p ON a.gml_id=ANY(p.hat) WHERE p.gml_id= $1 ORDER BY a.gml_id DESC ;";

	$v = array($gmlid);
	$resa = pg_prepare("", $sqla);
	$resa = pg_execute("", $v);
	if (!$resa) {
		echo "\n<p class='err'>Fehler bei Adressen</p>\n";
		if ($debug > 2) {echo "<p class='err'>SQL=<br>".$sqla."<br>$1=gml(Person)= '".$gmlid."'</p>\n";}
	}

	$j=0;
	// Parameter $multiadress = j zeigt ALLE Adressen an
	while($rowa = pg_fetch_array($resa)) {
		$j++;
		if ($multiadress == "j" OR $j == 1) {
			$gmla=$rowa["gml_id"];
			$plz=$rowa["plz"];
			$ort=htmlentities($rowa["ort_post"], ENT_QUOTES, "UTF-8");
			$str=htmlentities($rowa["strasse"], ENT_QUOTES, "UTF-8");
			$hsnr=$rowa["hausnummer"];
			$land=htmlentities($rowa["bestimmungsland"], ENT_QUOTES, "UTF-8");
			echo "<table>\n"
				."\t<tr><td class='nhd'>PLZ:</td><td class='nam'>".$plz."</td></tr>\n"
				."\t<tr><td class='nhd'>Ort:</td><td class='nam'>".$ort."</td></tr>\n"
				."\t<tr><td class='nhd'>Strasse:</td><td class='nam'>".$str."</td></tr>\n"
				."\t<tr><td class='nhd'>Hausnummer:</td><td class='nam'>".$hsnr."</td></tr>\n"
				."\t<tr><td class='nhd'>Land:</td><td class='nam'>".$land."</td></tr>\n"
			."\n</table>\n<br>\n";

			// Name und Adresse Kompakt (im Rahmen) - Alles was man fuer ein Anschreiben braucht
			echo "<img src='ico/Namen.png' width='16' height='16' alt='Brief' title='Anschrift'>"
			."\n<div class='adr' title='Anschrift'>".$anr." ".$aka." ".$vor." ".$nbest." ".$nam."<br>"
			."\n".$str." ".$hsnr."<br>"
			."\n".$plz." ".$ort."</div>";
		}
	}
	pg_free_result($resa);
	if ($j == 0) {
		echo "\n<p class='err'>Keine Adressen.</p>\n";
	} elseif ($j > 1) {
		echo "\n\t\t<p class='nwlink noprint'>"
		."\n\t\t\t<a href='".$_SERVER['PHP_SELF']. "?gkz=".$gkz."&amp;gmlid=".$gmlid;
		if ($showkey) {echo "&amp;showkey=j";}
		if ($multiadress == "j") {
			echo "&amp;multiadress=n' title='mehrfache Adressen unterdr&uuml;cken'>erste Adresse ";
		} else {
			echo "&amp;multiadress=j' title='Adressen ggf. mehrfach vorhanden'>alle Adressen ";
		}
		echo "\n\t\t\t</a>"
		."\n\t\t</p>";
	}

	// *** G R U N D B U C H ***
	echo "\n<hr>\n<h3><img src='ico/Grundbuch_zu.png' width='16' height='16' alt=''> Grundb&uuml;cher</h3>\n";
	// person <benennt< namensnummer >istBestandteilVon>                Buchungsblatt
	//                               >bestehtAusRechtsverhaeltnissenZu> namensnummer   (Nebenzweig/Sonderfälle?)

	$sqlg ="SELECT n.gml_id AS gml_n, n.laufendenummernachdin1421 AS lfd, n.zaehler, n.nenner, g.gml_id AS gml_g, g.bezirk, g.buchungsblattnummermitbuchstabenerweiterung as nr, g.blattart, wb.v AS blattartv, b.bezeichnung AS beznam 
	FROM ax_person p JOIN ax_namensnummer n ON p.gml_id=n.benennt 
	JOIN ax_buchungsblatt g ON g.gml_id=n.istbestandteilvon 
	LEFT JOIN ax_buchungsblattbezirk b ON g.land=b.land AND g.bezirk=b.bezirk 
	LEFT JOIN alkis_wertearten wb ON cast(g.blattart AS character varying)=wb.k AND wb.element='ax_buchungsblatt' AND wb.bezeichnung='blattart'
	WHERE p.gml_id= $1
	ORDER BY b.bezeichnung, g.buchungsblattnummermitbuchstabenerweiterung, n.laufendenummernachdin1421;";
	// buchungsblatt... mal mit und mal ohne fuehrende Nullen, bringt die Sortierung durcheinander

	$v = array($gmlid);
	$resg = pg_prepare("", $sqlg);
	$resg = pg_execute("", $v);

	if (!$resg) {
		echo "\n<p class='err'>Fehler bei Grundbuch</p>\n";
		if ($debug > 2) {echo "\n<p class='err'>SQL=".$sqlg."</p>\n";}
	}
	echo "<table class='eig'>"
	."\n<tr>"
		."\n\t<td class='heads'>Bezirk<img src='ico/sort.png' width='10' height='10' alt='' title='Sortierung'></td>"
		."\n\t<td class='head'>Blattart</td>"
		."\n\t<td class='heads'>Blatt<img src='ico/sort.png' width='10' height='10' alt='' title='Sortierung'></td>"
		."\n\t<td class='heads'>Namensnummer<img src='ico/sort.png' width='10' height='10' alt='' title='Sortierung'></td>"
		."\n\t<td class='head'>Anteil</td>"
		."\n\t<td class='head nwlink noprint' title='Link: weitere Auskunft'>weit. Auskunft</td>"
	."\n</tr>";

	$i=0;
	while($rowg = pg_fetch_array($resg)) {
		$gmln=$rowg["gml_n"];
		$gmlg=$rowg["gml_g"];
		$namnum=kurz_namnr($rowg["lfd"]);
		$zae=$rowg["zaehler"];
		$blattkey=$rowg["blattart"]; // Key
		$blattart=$rowg["blattartv"]; // Value

		echo "\n<tr>"
			."\n\t<td class='gbl'>"; // GB-Bezirk"
				if ($showkey) {echo "<span class='key'>".$rowg["bezirk"]."</span> ";}
				echo $rowg["beznam"]
			."</td>";

			echo "\n\t<td class='gbl'>"; // Blattart
				if ($showkey) {echo "<span class='key'>".$blattkey."</span> ";}
				echo $blattart
			."</td>";

			echo "\n\t<td class='gbl'>"; // Blatt
				echo "<span class='wichtig'>".$rowg["nr"]."</span>"
			."</td>";

			echo "\n\t<td class='gbl'>"; // Namensnummer
				if ($namnum == "") {
					echo "&nbsp;";
				} else {
					echo $namnum;
				}
			echo "</td>";

			echo "\n\t<td class='gbl'>"; // Anteil
				if ($zae == "") {
					echo "&nbsp;";
				} else {
					echo $zae."/".$rowg["nenner"]." Anteil";
				} 
			echo "</td>"
			."\n\t<td class='gbl'>"
				."\n\t\t<p class='nwlink noprint'>"
					."\n\t\t\t<a href='alkisbestnw.php?gkz=".$gkz."&amp;gmlid=".$gmlg;
						if ($showkey) {echo "&amp;showkey=j";}
						echo "' title='Bestandsnachweis'>".$blattart
					."\n\t\t\t<img src='ico/GBBlatt_link.png' width='16' height='16' alt=''></a>"
				."\n\t\t</p>"
			."\n\t</td>"
		."\n</tr>";
		// +++ >bestehtAusRechtsverhaeltnissenZu> namensnummer ?
		// z.B. eine Namennummer "Erbengemeinschaft" zeigt auf Namensnummern mit Eigentümern
		$i++;
	}
	pg_free_result($resg);
	echo "</table>";
	if ($i == 0) {echo "\n<p class='err'>Kein Grundbuch.</p>\n";}
} else {
	echo "\n\t<p class='err'>Fehler! Kein Treffer f&uuml;r\n\t<a target='_blank' href='alkisrelationen.php?gkz=".$gkz."&amp;gmlid=".$gmlid."'>".$gmlid."</a>\n</p>\n\n";
}
?>

<div class='buttonbereich noprint'>
<hr>
	<a title="zur&uuml;ck" href='javascript:history.back()'><img src="ico/zurueck.png" width="16" height="16" alt="zur&uuml;ck"></a>&nbsp;
	<a title="Drucken" href='javascript:window.print()'><img src="ico/print.png" width="16" height="16" alt="Drucken"></a>&nbsp;
	<a title="Export als CSV" href='javascript:ALKISexport()'><img src="ico/download.png" width="16" height="16" alt="Export"></a>&nbsp;
</div>

<?php footer($gmlid, $_SERVER['PHP_SELF']."?", ""); ?>

</body>
</html>